var path = require('path');
var crypto = require('crypto');
var fs = require('fs');

exports = module.exports = function certificates(options) {
  certs = options;

  for(var item in certs) {
    var c = certs[item];

    if("string" == typeof c) {
      certs[item] = {};
      certs[item].credentials = loadCredentials(certs[c]);
    } else {
      certs[item].credentials = loadCredentials(certs[item]);
    }
  }

  return function(hostname) {
    if(certs[hostname]) return certs[hostname].credentials.context;
    
    return null;
  };
};

function loadCredentials(options) {
  var details = {
      key: fs.readFileSync(get_path(options.key)),
      cert: fs.readFileSync(get_path(options.cert)),
      ca: []
    };

    if("string" == typeof options.ca) options.ca = [options.ca];

    options.ca.forEach(function(file) {
      details.ca.push(fs.readFileSync(get_path(file)));
    });

  return crypto.createCredentials(details);
}

function getDomain(hostname) {
  var d = hostname.split(':')[0].split('.');
  if(d.length > 2) d.shift();

  return d.join('.');
}


function get_path(filename) {
  var app_path = path.dirname(require.main.filename);

  return path.resolve(app_path, filename);
}