exports = module.exports = function helpers(options) {
  var target = options.target;

  return function(req, res, next) {
    req.target = target;

    req.secure = (typeof req.connection.encrypted != 'undefined');
    req.hostname = (req.headers.host || req.connection.localAddress).split(':')[0];
    req.has_hostname = !isIPAddress(req.hostname);

    if(req.has_hostname) {
      req.host_domain = domain(req.hostname);
    }

    next();
  };
};

function isIPAddress(hostname) {
  return /^(?:[0-9]{1,3}\.){3}[0-9]{1,3}$/.test(hostname);
}

function domain(hostname) {
  var d = hostname.split(':')[0].split('.');
  if(d.length > 2) d.shift();

  return d.join('.');
}
